'use strict';

let _ = require('lodash');
let request = require('sync-request');
let util = require('../../util');
let http = require('http');
let req = require('request');
let Promise = require('bluebird');
let pageAssets = require('../page-assets');

let assetsDule = module.exports = {
  replaceSolutionAssets: function(xtpl, options) {
    //种子资源的特殊处理
    let seed = options.seed;
    let seedContent = util.comboAssets(['require','mloader'],seed);
    seedContent = assetsDule.getAssetsContent(seedContent.js['g.alicdn.com']);
    xtpl = xtpl.replace('{{frameworkSeedJs}}', seedContent);
    return xtpl;
  },
  /**
   * 通过资源地址获取资源内容
   * @param assetPath
   */
  getAssetsContent: function(assetPath){
    let content = '';
    //将js内容远程读取后直接注入
    let res = request('GET', assetPath.replace(/^\/\//, 'http://'));
    if (res.statusCode === 200) {
      content = res.getBody().toString();
    }
    return content;
  },
  /**
   * air 渲染后执行的方法
   * 在线上不起作用，主要用于dev与预览环境
   */
  afterAirRenderContentReplace: function*(content,airParams,option){
    return content;
  }
};
