var pageJsonToXtpl = require('../index');
var fs = require('fs');
var fixtures = require('./fixtures/rx');
const chai = require('chai');
const expect = chai.expect;
const sinon = require('sinon');
const co = require('co');

pageJsonToXtpl.setType('rx-bundle');

function getJson(url) {
  var testJson = fs.readFileSync(url);
  return JSON.parse(testJson.toString());
}


describe('render mods test', ()=> {
  describe('#renderModulesNoAir()', ()=> {
    it('return html', (done)=> {

      var modules = fixtures.modules;
      co(function*() {
        var d = yield pageJsonToXtpl.renderModulesNoAir(modules);
        // console.log(d);
        done();
      })
    });
  });
  describe('#renderModules()', ()=> {

    it('return html', (done)=> {
      var config = {
        "layout": {
          "version": "v1",
          "modules": fixtures.modules
        },
        assets:fixtures.solutionAssets
      };

      co(function*() {
        var d = yield pageJsonToXtpl.renderModules(config,{bundle:false});
        // console.log(d);
        done();
      })


    })
  });

});

describe('solution', ()=> {
  describe('#renderSolution()', ()=> {
    it('should render solution', (done)=> {
      const solution = {
        assets: fixtures.solutionAssets
      };
      return pageJsonToXtpl.renderSolution(solution).then(
        function(d) {
          // console.log(d);
          done();
        }
      );
    })
  });
});



describe('run', ()=> {
  describe('#run bundle()', ()=> {
    it('return script', (done)=> {
      co(function*() {
        var html = yield pageJsonToXtpl.run(fixtures.pageData);
        // console.log(html);
        done();
      });
    })
  });

});






